import peasy.*;
import controlP5.*;
PeasyCam cam;
Table duration;
Table amount;
Table amount_month;
int numRowsD, numColsD, numRowsA, numColsA, monthRows, monthCols;
float [][] MatrixD;
float [][] MatrixA;
float [][] MatrixMD;
float [][] MatrixMA;

float [][] month;
float[] spacers = {600, 610, 620, 630, 640, 650, 660, 670, 680, 690};
int SPHERE_NUM;
ArrayList<Sphere> spheres;
float ORBITAL_RADIOUS = 100;
float SPHERE_RADIOUS = 100;
float SPHERE_RADIAN_SPEED = 0;
float constant = 4;
float SR;
float radian1;
float radian2;
float radianSpeed1;
color [] colors = {#D9DDD8, #FBABA8, #98D0BF, #7DBFD5, #9A879D, #555854, #722e29, #1F4e40, #083f51, #353c42};  
int opacity = 50;
//int opacity2 = 0;
boolean year = false;
int years;
int position = -30;
PShape mercury;
int o = 1;
float x, y,z;

ControlP5 cp5;
Slider abc;
//int space = 100;
//need to get each column to create a sphere
//call sphere class for each size of the sphere and rotation speed
//and then after all the years readjust the radius for the next dewey class

void setup() {
  size(1000, 1000, P3D);
  cam = new PeasyCam(this, 300);
  cp5 = new ControlP5(this);
  duration = loadTable("planet_duration.csv", "header");
  amount = loadTable("planet_amount.csv", "header");
  amount_month = loadTable("amount_month.csv", "header");
  numRowsD = duration.getRowCount();
  numColsD = duration.getColumnCount();
  numRowsA = amount.getRowCount();
  numColsA = amount.getColumnCount();
  monthRows = amount_month.getRowCount();
  monthCols = amount_month.getColumnCount();
  println(monthCols, monthRows);
  //println();

  for (int i=0; i< duration.getRowCount()-2; i++) {
    spacers[i] = map(spacers[i], 600, 690, 0, width);
    //spacers[i] = duration.getFloat(0,i);
  }
  //printArray(spacers);

  //println(numColsD);
  MatrixD = new float[numColsD][numRowsD];
  MatrixA = new float[numColsA][numRowsA];
  MatrixMD = new float[numColsD][numRowsD];
  MatrixMA =  new float [numColsA][numRowsA];
  month = new float[monthRows][monthCols];

  //i = rows and j = cols
  for ( int i = 0; i < numRowsD; i++) {
    for (int j = 1; j < numColsD-1; j++) {
      MatrixD[i][j] = duration.getFloat(i, j);
      MatrixMD[i][j] = map(duration.getFloat(i, j), 0, 100, 0, width);
      //printArray(MatrixD[i][j]);
    }
  }
  for(int i =0; i < monthRows; i++){
    for(int j = 0; j < monthCols; j++){
      month[i][j] = amount_month.getFloat(i,j);
      //println("J: " +j);
     // printArray(month[i][j]);
    }
  }
  
  mercury = createShape();
  for(int i = 0; i < monthRows; i++){
     //x = map(month[i][1], 0, 11, spacers[1]*12+i*300-100, spacers[1]*12+i*300+100);
     //y = map(month[i][0], 2006, 2016, spacers[1]*12+i*300-100, spacers[1]*12+i*300+100);
     //z = map(month[i][2], 49, 4046, spacers[1]*12+i*300-100, spacers[1]*12+i*300+100);
     x = map(month[i][1], 0, 11, spacers[1]*12-i*300, spacers[1]*12+i*300);
     y = map(month[i][0], 2006, 2016, spacers[1]*12-i*300, spacers[1]*12+i*300);
     z = map(month[i][2], 49, 4046, spacers[1]*12-i*300, spacers[1]*12+i*300);
     mercury.beginShape(TRIANGLE_STRIP);
     mercury.strokeWeight(1);
     mercury.stroke(255);
     mercury.noFill();
     translate(width/2, height/2, spacers[1]);
     mercury.vertex(x,y,z);
     mercury.vertex(month[0][1],month[0][0], month[0][2], spacers[1]*12-i*300, spacers[1]*12+i*300);
     //i = monthRows;
     println(x/100,y/100,z/100);
  }
 // mercury.vertex(month[0][1],month[0][0], month[0][2]);
  mercury.endShape();
  
  for ( int i = 0; i < numRowsA; i++) {
    for (int j = 1; j < numColsA-1; j++) {
      MatrixA[i][j] = amount.getFloat(i, j);
      MatrixMA[i][j] = map(duration.getFloat(i, j), 0, 100, 0, width);
    }
  }
}
void draw() {
  background(0);
  surface.setResizable(true);
  pushMatrix();
  rotateY(radians(90));
  scale(0.75);
  shape(mercury, width/2, height/2);
  popMatrix();
  
  for (int i =0; i < 4; i++) {
    pushMatrix();
    noFill();
    translate(width/2, height/2, spacers[i]);
    stroke(255, opacity);
    ellipse(0, 0, spacers[1]*12+i*300, spacers[1]*12+i*300);
    popMatrix();
    //o = 1;
  }
  for (int i =4; i <9; i++) {
    pushMatrix();
    noFill();
    translate(width/2, height/2, spacers[i]);
    stroke(255, opacity);
    ellipse(0, 0, spacers[1]*12+i*300+80, spacers[1]*12+i*300+80);
    popMatrix();
  }
  ArrayList<Sphere> spheres = new ArrayList<Sphere>();
  int k = 0;
  for ( int i = 0; i < numRowsA; i++) {
    if (k<numColsA-2) {
      for (int j = 1; j < numColsA-1; j++) {
        if (!year) {
          Sphere a = new Sphere(MatrixD[i][j], MatrixA[i][j], spacers[k], colors[j-1]);
          spheres.add(a);
        }
        else {
          Sphere a = new Sphere(MatrixD[i][years], MatrixA[i][years], spacers[k], colors[years-1]);
          spheres.add(a);
        }
      }
    }
    k+=1;
  }
  //println();
  for (int i = 0; i < spheres.size(); i++) {
    spheres.get(i).draw();
    spheres.get(i).update();
  }
  //spheres.add(new Sphere());
  //println(j);
}













//i = numRowsA-1;


//for (int i=0; i< 20; i++) {
//  //SPHERE_NUM = numRowsD;

//  //SPHERE_RADIOUS = MatrixD[i][2]/constant;
//  spheres.add(new Sphere());
//}
//for (int i = 1; i < numRowsD-1; i++) {
//  for (int j =0; j < numColsD; j++) {
//    SPHERE_RADIOUS[j] =  MatrixD[i][j]/constant; 
//  }
//spheres.add(new Sphere());
//}
//}

//void draw() {
//background(255);
//fill(150, 150);
//pushMatrix();
//translate(width/2, height/2, 100);
//sphere(50);
//popMatrix();
//for(int i = 0; i < numColsD; i++){
//  spheres.get(i).
//for (int i = 0; i < numColsD; i++) {
//  for (int j = 1; j < SPHERE_NUM-1; j++) {
//    radian1 = random(PI * 2);
//    radian2 = random(PI * 2);
//    radianSpeed1 = random(1) < 0.5 ? SPHERE_RADIAN_SPEED : -1.0 * SPHERE_RADIAN_SPEED;
//    fill(100, 10);
//    pushMatrix();
//    translate(width/2, height/2, 100);
//    translate(ORBITAL_RADIOUS * sin(radian1) * cos(radian2), ORBITAL_RADIOUS * sin(radian1) * sin(radian2), ORBITAL_RADIOUS * cos(radian1));
//    sphere(MatrixD[i][j]);
//    popMatrix();
//  }
//}
//for (int i = 0; i < SPHERE_NUM; i++) {
//  spheres.get(i).update();
//}
//}